#include "mbed.h"
#include "C12832_lcd.h"
#include <string>
#include <stdio.h>
#include <stdlib.h>

Serial pc(USBTX, USBRX);
Serial wifi(p9,p10);
PwmOut M1(p21);
PwmOut M2(p22);
PwmOut M3(p23);
PwmOut M4(p24);

int send(const char * str, int len)         //functie om commando te schrijven naar wifly
{
    for(int i = 0; i < len; i++)
    {
        wifi.putc(str[i]);                  //schrijft commando karakter per karakter in de wifly
    }
}
int richting(char c,float value)            //functie bepaalt richting en pwm waarde
{
   float waarde;                           
   waarde = value/100;                      //value is waarde achter de komma, value/100 is komma getal geschikt voor pwm                 
           
            if(c == '1')                    
              {
                    M1 = waarde;
                    M2 = 0;
                    M3 = waarde;
                    M4 = 0;      
              }
              else if(c == '2')
              {
                    M1 = 0;
                    M2 = waarde;
                    M3 = 0;
                    M4 = waarde;
              }
              else if(c == '3')
              {
                    M1 = 0;
                    M2 = waarde;
                    M3 = waarde;
                    M4 = 0;  
              }
              else if(c == '4')
              {
                    M1 = waarde;
                    M2 = 0;
                    M3 = 0;
                    M4 = waarde; 
              }
              else if(c == '0')
              {
                    M1 = 0;
                    M2 = 0;
                    M3 = 0;
                    M4 = 0;       
              } 
}
void wifi_config()                      //wifi_config schrijft commando's in wifly om adhoc op te zetten
{
    send("$$$",3);                      //commando om wifly in command mode te zetten
        pc.putc(wifi.getc());           //print acknowledge
        pc.putc(wifi.getc());
        pc.putc(wifi.getc());
        
        send("\nset w j 4",11);         //set wlan join 4
        pc.putc(wifi.getc());           
        pc.putc(wifi.getc());
        pc.putc(wifi.getc());
        while(wifi.readable())          //print ack
            pc.putc(wifi.getc());
   
        send("\nset w s EDU_robot",19); //set wlan ssid EDU_robot
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());           //print ack
  
        send("\nset w c 1",11);                 //set wlan channel 0
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
 
        send("\nset i a 169.254.1.1",21);           //set ip adress 169.254.1.1
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());               //print ack
            
        send("\nset i n 255.255.0.0",21);           //set ip netmask 255.255.0.0   
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
               
        send("\nset i d 0",11);                     //set ip dhcp 0
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
                
        send("\nset c c *",11);                     //set command close *
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
                
        send("\nset c o 0",11);                     //set command open 0
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
                
        send("\nset c r 0",11);                     //set command remote 0
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
            
        send("\nsave",6);                           //save settings
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            pc.putc(wifi.getc());
            while(wifi.readable())
                pc.putc(wifi.getc());
            
        send("\nreboot",8);                         //reboot module
        pc.putc(wifi.getc());
        pc.putc(wifi.getc());
        pc.putc(wifi.getc());
        while(wifi.readable())
            pc.putc(wifi.getc());
        wait(1);
}

int main() {

    char c;                                 //c slaagt inkomenbde karakters op
    string str = "";                        //string van inkomende karakters tot '*'(close connection command)
    string pwm = "";                        //deel van string met pwm waarde
    int value =0;                           //variabele voor de omzetting van string van pwm
    pc.printf("Test Wifly!\r\n");           //print test wifly!!
    
    wifi_config();                          //functie om adhoc op te zetten
        
    while(1)
    { 
        send("Hallo",5);
        wait(0.01);
            while(wifi.readable())
            { 
              c = wifi.getc();                              //inkomend karakter is opgeslagen in c
              if(c == '*')                                  //wanneer inkomend karakter gelijk is aan '*'
              {
                  pwm = str.substr(3,2);                    //laatste deel van string opslaan in string pwm              
                  value = (double)atof(pwm.c_str());        //string van pwm omzetten in double
                  richting(str[0],value);                   //richting bepalen + motoren juist aansturen
                  str = "";                                 //string terug leegmaken
              }
              else
              { 
                str = str + c;                              //als karakter nog niet gelijk is aan '*' string vullen
              }
              
            }
    }
}